var languageObject = require( "../parser.js" ).LanguageObject;
var i = new languageObject( "doq" );
var r = i.syntaxObject;
i.AddRule( "connection" );
i.AddRule( "connectionName" );
i.AddRule( "table" );
i.AddRule( "tableName" );
i.AddRule( "tableSelection" );
i.AddRule( "tableSelectionList" );
i.AddRule( "tableSelectionItem" );
i.AddRule( "tableQuery" );
i.AddRule( "tableQueryList" );
i.AddRule( "tableSeperator" );
i.AddRule( "tableStatment" );
i.AddRule( "tableLogicSwitch" );
i.AddRule( "column" );
i.AddRule( "columnName" );
i.AddRule( "selectionStyle" );
i.AddRule( "selectAll" );
i.AddRule( "selectFirst" );
i.AddRule( "selectExecute" );
i.AddRule( "_char" );
i.AddRule( "_text" );
i.AddRule( "_digit" );
i.AddRule( "_cr" );
i.AddRule( "_lf" );
i.AddRule( "_crlf" );
i.AddRule( "_htab" );
i.AddRule( "_sp" );
i.AddRule( "_wsp" );
i.AddRule( "_wspchar" );
i.AddRule( "_owsp" );
i.AddRule( "_digits" );
i.AddRule( "_number" );
i.AddRule( "_literal" );
i.AddRule( "_literalSingleQuotes" );
i.AddRule( "_literalDoubleQuotes" );
i.AddRule( "_literalCharSingleQuotes" );
i.AddRule( "_literalCharDoubleQuotes" );
i.AddRule( "_anyLiteralChar" );
i.IndexTokenIdList();
i.WriteRule( "syntax", i.And( r.connection, "/", r.table, "/", r.column, r.selectionStyle ) );
i.WriteRule( "connection", i.And( "@", r.connectionName ) );
i.WriteRule( "connectionName", r._text );
i.WriteRule( "table", i.Or( i.And( r.tableName, r.tableSelection, r.tableQuery ), i.And( r.tableName, r.tableQuery ), r.tableName ) );
i.WriteRule( "tableName", r._text );
i.WriteRule( "tableSelection", i.And( ":", r.tableSelectionList ) );
i.WriteRule( "tableSelectionList", i.Or( r.tableSelectionItem, i.And( r.tableSelectionItem, r._owsp, ",", r._owsp, r.tableSelectionList ) ) );
i.WriteRule( "tableSelectionItem", r._text );
i.WriteRule( "tableQuery", i.And( "[", r._owsp, r.tableQueryList, r._owsp, "]" ) );
i.WriteRule( "tableQueryList", i.Or( r.tableStatment, i.And( r.tableStatment, r._wsp, r.tableSeperator, r._wsp, r.tableQueryList ) ) );
i.WriteRule( "tableSeperator", i.Or( "and", "or" ) );
i.WriteRule( "tableStatment", i.And( r._text, r._owsp, r.tableLogicSwitch, r._owsp, r._literal ) );
i.WriteRule( "tableLogicSwitch", i.Or( "!=", "=" ) );
i.WriteRule( "column", i.Or( i.Blank(), i.Include( 'filters' ) ) );
i.WriteRule( "columnName", r._text );
i.WriteRule( "selectionStyle", i.Or( r.selectAll, r.selectFirst, r.selectExecute ) );
i.WriteRule( "selectAll", "*" );
i.WriteRule( "selectFirst", "$" );
i.WriteRule( "selectExecute", "!" );
i.WriteRule( "_char", i.Or( i.CharGroup( "A", "Z" ), i.CharGroup( "a", "z" ), "_" ) );
i.WriteRule( "_text", i.Or( r._char, i.And( r._char, r._text ) ) );
i.WriteRule( "_digit", i.And( i.CharGroup( "0", "9" ) ) );
i.WriteRule( "_cr", "\r" );
i.WriteRule( "_lf", "\n" );
i.WriteRule( "_crlf", i.Or( i.And( r._cr, r._lf ), i.Or( r._cr, r._lf ) ) );
i.WriteRule( "_htab", "\t" );
i.WriteRule( "_sp", " " );
i.WriteRule( "_wsp", i.Or( r._wspchar, i.And( r._wspchar, r._wsp ) ) );
i.WriteRule( "_wspchar", i.Or( r._htab, r._sp ) );
i.WriteRule( "_owsp", i.Or( i.Blank(), r._wsp ) );
i.WriteRule( "_digits", i.Or( r._digit, i.And( r._digit, r._digits ) ) );
i.WriteRule( "_number", i.Or( r.digits, i.And( r.digits, ".", r.digits ) ) );
i.WriteRule( "_literal", i.Or( i.And( "'", r._literalSingleQuotes, "'" ), i.And( '"', r._literalDoubleQuotes, '"' ) ) );
i.WriteRule( "_literalSingleQuotes", i.Or( i.Blank(), r._literalCharSingleQuotes, i.And( r._literalCharSingleQuotes, r._literalSingleQuotes ) ) );
i.WriteRule( "_literalDoubleQuotes", i.Or( i.Blank(), r._literalCharDoubleQuotes, i.And( r._literalCharDoubleQuotes, r._literalDoubleQuotes ) ) );
i.WriteRule( "_literalCharSingleQuotes", i.Or( r._anyLiteralChar, '"', "\\'" ) );
i.WriteRule( "_literalCharDoubleQuotes", i.Or( r._anyLiteralChar, '\\"', "'" ) );
i.WriteRule( "_anyLiteralChar", i.Or( i.CharGroup( " ", "!" ), i.CharGroup( "#", "&" ), i.CharGroup( "(", "[" ), i.CharGroup( "]", "~" ) ) );
exports.interpreter = i;